
package FDL;

import java.util.*;
import FDL.workingmap.*;
import FDL.term.*;

public class test {
    public static void main (String[] argv)  throws Exception {

	//FDLApi0 forb = new FDLApi0 ("nuprlgateway.cs.cornell.edu", 6074, "fps");
	FDLApi0 forb = new FDLApi0 ("nuprl2", 6074, "release");
	
	ArrayList parms = new ArrayList ();
	ArrayList sterms = new ArrayList ();

	parms.add(new SParameter ("t", "bar"));
	sterms.add(new Term(parms, new ArrayList()));
	Term t = new Term (parms, sterms);

	System.out.print("Before OPEN\n");
	forb.open();

	System.out.print("OPEN\n");

	Term r;
	try {
	    System.out.print("BeforeEcho\n");

	    r = forb.echo(t);
	    System.out.print("AfterEcho\n");
	    Boolean p = new Boolean(r.equals(t));
	    System.out.print(r.toString() + "\n" + p.toString() + "\n");
	}
	catch (TermException e) {
	    System.out.print(e.toString());
	}

	try {
	    ObjectId obid = forb.createObjectId();

	    /*
	    forb.evalPut(obid,t);
	    forb.evalPutName(obid, "fubar");
	    //System.out.println("put done");

	    r = forb.evalGet(obid);
	    //System.out.println("get done");

	    //System.out.println(r.toString());

	    r = forb.evalGetProperty(obid, "NAME");
	    //System.out.println(r.toString());

	    ObjectId pobid = forb.evalCreateObjectId();
	    forb.evalPutProperty(obid, pobid, t);
	    //System.out.println("put property o done");

	    r = forb.evalGetProperty(obid, pobid);
	    //System.out.println("get property o done");
	    //System.out.print(r.toString());
	    */

	    String path[] = {"local", "tmp"};
	    ObjectId dobid = forb.dirDescendent(path);

	    r = forb.getProperty(dobid, "NAME");
	    System.out.println(r.toString());

	    //ObjectId mobid = forb.mkDir("test-mkdir");
	    //forb.dirInsert(true, dobid, mobid);
	    
            ObjectId mobid = forb.mkDir(true, dobid, "test-mkdir");
	    //forb.dirInsert(true, dobid, mobid);
	    
	    Parameter[] p = {SParameter.opidParm("!text"), SParameter.stringParm("s")};
	    Term[] ts = { };
	    Term tt = new Term(SParameter.opidParm("bar"));
	    ObjectProperty [] props = { new ObjectProperty("fu", tt)};
	
	    ObjectId bobid = forb.makeObject("CODE", props, new Term(p, ts));
	
	    forb.putName(bobid, "b");
	    forb.dirInsert(true, mobid, bobid);

	    Term pt = forb.getProperty(bobid, "fu");
	    if (!(tt.equals(pt))) { 
		throw new Exception("parameter not what expected " + pt.toString() + " " + tt.toString()); }
	    tt = new Term(SParameter.opidParm("bat"));
	    forb.putProperty(bobid, "fu", tt);
	    pt = forb.getProperty(bobid, "fu");
	    if (!(tt.equals(pt))) { 
		throw new Exception("parameter not what expected " + pt.toString() + " " + tt.toString()); }

	    p[0] = SParameter.opidParm("!text");
            p[1] = SParameter.stringParm("t");
	    //props[0] = new ObjectProperty("foo", new Term(SParameter.opidParm("bar")));
	    //tt = new Term(SParameter.opidParm("bat"));

	    ObjectId aobid = forb.createObjectId();
	    props[0] = new ObjectProperty(aobid, tt);

	    forb.modifyObject(bobid, "TERM", props, new Term(p,ts));
	    forb.putName(bobid, "b");
	    pt = forb.getProperty(bobid, aobid);
	    if (!(tt.equals(pt))) { 
		throw new Exception("parameter not what expected " + pt.toString() + " " + tt.toString()); }

	    tt = new Term(SParameter.opidParm("bas"));
	    forb.putProperty(bobid, aobid, tt);
	    pt = forb.getProperty(bobid, aobid);
	    if (!(tt.equals(pt))) { 
		throw new Exception("parameter not what expected " + pt.toString() + " " + tt.toString()); }


	    forb.put(aobid,new Term(SParameter.opidParm("a")));
	    forb.putName(aobid, "a");
	    forb.dirInsert(true, bobid, mobid, aobid);

            ObjectId cobid = forb.createObjectId();
	    Term pct = new Term(SParameter.opidParm("c"));
	    forb.put(cobid,pct);
	    forb.putName(cobid, "c");
	    forb.dirInsert(false, mobid, cobid);
	    Term ct = forb.get(cobid);
	    if (!(ct.equals(pct))) { 
		throw new Exception("parameter not what expected " + pt.toString() + " " + tt.toString()); }

	    ObjectId xobid = forb.mkDir(false, bobid, mobid, "d");
	    forb.dirRemove(mobid, cobid);
	    
	    String[] xpath = {"local", "tmp", "test-mkdir", "d"};
	    if ((forb.dirDescendent(xpath)).equals(xobid)) {
		System.out.println("dirDescendent good");
	    }
	    else { System.out.println("dirDescendent bad");}
	}

	catch (TermException e) {
	    System.out.print(e.toString());
	}

	forb.close();
    }

}
