

%

old
simp =   tok {id} # tok{op} #
         (env -> term -> bool) {pred} # 
         convn

 id tok -> tok{opid} # obid {update}    ;; opid for quick check.
 op tok -> obid{abs}

 add note hook : calls note re-update with kind (obid) and update(obid).
  * called when pred matches.

 how to access lookup updates
   by obid alist - find obid of instance then apply alist.
     - if no match abs ? require an abs (use null for prims)
     + reduce dependency on opid.
     - expensive to lookup obid.
   by opid alist list - find list then check each.
     - expensive to check obids.

2d alist by opid then obid

update could be

update : ((tok # object) # x) list

data,cdata : (tok # ((objectid # x) list) list

simps

simpsets

  - tok # (object id) list
     for each simp if obid of simpset context is member of list then in simpset.

  each simpset update specifies list of simp update obids

  then the simpset index specifies a list of simp update obids
   if conflicting simps then later simpsets should take precedence
       thus want ordered by simpset somehow.

    consider simp a b c

     simpset A specifies a b
     simpset B specifies c

     re contans A,B updates then c a b to be simp update list
     this (or the reverse) is probably true by default.
      - test
     


     would be nice if simpset context was list, ie each simp could be in multiple
     simp-set contexts, but then simpset add would need to modify simp_ref_state
     such mod need not be treated as ref-env since simpset ref-env controls at lookup.

     if no sharing then what benefit to having simps and simpset simps in same refstate
        - shadowing - simpset context used to sort applicable simps.

quicksort (\a b. a < b or a = b) [1; 3; 2];;	
          [1; 2; 3] : int list

%

let opid_obid_data_merge cdata data =
 letrec auxob oba obdata  =
   if null obdata then oba
   else let obid, x = hd obdata in
          auxob (update_alist_p oba obid
				(x @ (apply_alist_p oba obid equal_oids_p ? []))
				equal_oids_p)
	        (tl obdata)

 and auxop cdata data =
 if null data then cdata else
 let (opid, obalist) = hd data in
   let opalist = apply_alist cdata opid ? [] in
   let obs = auxob opalist obalist in
    auxop (update_alist cdata opid obs) (tl data) in

    auxop data cdata
;;

let opid_obid_merge_updates updates = 
 letrec aux cdata updates = 
  if null updates then cdata 
  else let (opid,obid), x = hd updates in
       let oplist = apply_alist cdata opid ? [] in
       let oblist = apply_alist_p oplist obid equal_oids_p ? [] in
       aux (update_alist cdata opid 
              (update_alist_p oplist obid (x . oblist) equal_oids_p))
           (tl updates)

 in aux nil (flatten updates)
;;


letref simp_ref_state =
 new_ref_state `simp`
   opid_obid_merge_updates
   opid_obid_data_merge
   ([] : (object_id
	   # (((tok # object_id)
	       #  ( object_id		% update %
		  # bool		% static %
                  # (unit -> unit)
		  % # (object_id list) %	% simpset context %
		  # (env -> (term -> bool))
		  # convn)) list)) list )
   ([] : (( tok				% opid %
	  # ( (object_id		% abs obid %
	         # (( object_id		% update %
		    # bool		% static %
		    # (unit -> unit)
		    %# (object_id list)%	% simpset context %
		    # (env -> (term -> bool))
		    # convn) list)
	      ) list)
	 ) list))
;;

update_ref_state_view
 (\ (). simp_ref_state)
 (ref_state_view_list_entry
    (\tok,obidsimps. 
          map_to_ilist (\obid,simps. 
                           make_term (`simp`, [make_object_id_parameter obid])
                               [[],map_to_ilist
                                      (\s. make_term (`simp`,[ make_bool_parameter (fst (snd s))
                                                             ; make_object_id_parameter (fst s)])
                                             [])
                                      icons_op simps])
                       icons_op
                       obidsimps))
;;

let destruct_simp_ref_state () =
 let g, upds, name, uf, ug = destruct_ref_state simp_ref_state
 in upds
;;

% yuk, need obid for variable term but can't define as abs.
%
letref variable_abs_proxy_obid = inl () : (unit + object_id);;
let is_variable_proxy_obid obid = equal_oids_p obid (outr variable_abs_proxy_obid);;
let set_variable_proxy_obid obid = variable_abs_proxy_obid := (inr obid);;

let simp_add_data oid data = 
 simp_ref_state  := ref_state_set_data simp_ref_state [oid, data];;

let opid_of_obid obid =
  id_of_term (fst (snd (abstraction_lookup obid)))
  ? if is_variable_proxy_obid obid
       then `variable`
       else failwith `opid_of_obid`
;;

let simp_add_o_aux staticp uobid data =
  reset_ref_environment_data uobid;
  add_ref_environment_data uobid `simp` simp_add_data
   (map (\ (obid, r). 
          ( (opid_of_obid obid, obid)
          , uobid
          , staticp
	  , (\ (). note_dependency `reference_environment_update` obid)
	  ,r)) 
        data)
;;

let simp_add_o = simp_add_o_aux true;;

let simpset_simp_add_o = simp_add_o_aux false;;

let undeclare_simp oid =
  (simp_ref_state := ref_state_remove simp_ref_state oid; ())
 ? ()
;;

add_ref_environment_undeclare_hook `simp` undeclare_simp;;

let ref_add_simp_aux index edges items =
 simp_ref_state
   := declare_ref_state_data_indirect `simp` simp_ref_state index items edges
;;

update_ref_state_merge `simp` (ref_state_merge_build `simp` ref_add_simp_aux)
;;

let simp_do_updates oid edges oids =
 %tty_print "simp_do_updates"; %%view_show_oids edges; view_show_oids oids;%
 simp_ref_state := ref_state_do_updates simp_ref_state oid oids edges
; % tty_print "simp_do_updates done";%
()
;;

add_reference_environment_update_hook `simp` simp_do_updates;;

    
letrec obid_for_simp t =
  if is_apply_term t then obid_for_simp (head_of_application t) 
  if is_var_term t then failwith `obid_for_simp`
  else obid_of_abstraction_term t
;;

letrec op_ob_for_simp t =
  if is_apply_term t then op_ob_for_simp (head_of_application t) 
  else if is_var_term t then failwith `op_ob_for_simp`
  else (id_of_term t, obid_of_abstraction_term t)
;;


% lists of simp update obids %
letref simpset_context = [] : (bool % add or delete % # object_id) list;;

% generated from hyps etc. %
letref ephemeral_simps = [] : (tok # tok # object_id # (env -> (term -> bool)) # convn) list
;;

let with_simpset_context_aux b l T p =
 let cur = simpset_context in
 simpset_context := if b then l @ cur else l;
 apply_and_cleanup T p (\(). simpset_context := cur)
;;

let with_simpset_context = with_simpset_context_aux true;;

let with_simpset_contextC l C e t =
 let cur = simpset_context in
 simpset_context := l @ cur;
 apply_and_cleanup (C e) t (\(). simpset_context := cur)
;;

let WESimps l T p =
 let cur_eph_simps = ephemeral_simps in
  %tty_print ("ephemeral_simps length = " J (int_to_string (length l)));%
  ephemeral_simps := l;
  %tty_print ("ephemeral_simps length = " J (int_to_string (length ephemeral_simps)));%
  apply_and_cleanup T p (\(). ephemeral_simps := cur_eph_simps)
;;

let WOESimps l T p =
  if null l then T p 
 else 
 let cur = ephemeral_simps in
  ephemeral_simps := filter (\(id, r). not (member id l)) cur;
  apply_and_cleanup T p (\(). ephemeral_simps := cur)
;;



%
  if matching ephemeral then look no further.
  if match abs obid of add then look no further.

  add/delete scope matters. More recent assumed to be earlier in list

 original simpsets code always deleted shadowed simps with same opid.
 this may have been done since no ordering was possible using former
 method, thus it may be okay to simply use simpsets to order simps.
 thus if pred disqualifies a simp then an earlier one may be used.
%

% Returns ` ` for vars. %
letrec opid_for_simp t =
  if is_apply_term t then opid_for_simp (head_of_application t) 
  if is_var_term t then ` `
  else opid_of_term t
;;

letrec term_for_simp t =
  if is_apply_term t then term_for_simp (head_of_application t) 
  else t
;;


let lookup_ephsimps e t = 
 let opid = opid_for_simp t in
  map (snd o snd o snd)
      (filter (\id,op,aobid,r.
                 op = opid &
                 (if not (opid = ` `) then abstraction_match_p t aobid else true)) 
              ephemeral_simps)
;;

% filters static unless no simpset?
 simp+ = update-obid # static-bool # note-f # pred # convn
 abslist == (simp+ list) %

let simpset_filter e t abslist =
 letrec aux deletes r =
  if null r then filter (\uobid, staticp, r.
                             staticp & not (member_p uobid deletes equal_oids_p))
                        abslist
  else
  let addp, uobid = hd r in
   if addp
      then if member_p uobid deletes equal_oids_p
              then aux deletes (tl r)
              %else ([uobid, apply_alist_p abslist uobid equal_oids_p] ? aux deletes (tl r))%
              else ( ( (filter (\uuobid, simp. equal_oids_p uobid uuobid)
                             abslist)
                     @ (aux deletes (tl r)))
                   ? aux deletes (tl r))
      else aux (uobid . deletes) (tl r)
  in aux [] (rev simpset_context)
;;

%hmm, original had lookup of null token to catch variables
  I suspect that had no effect except for hyp simps 
  which are now handled as ephsimps.
  However something to look into if things aren't working as expected.
%
let lookup_simp_convns e tt =
  let ephsimps = lookup_ephsimps e tt in
   if not (null ephsimps) 
      then map_omitting_failures (\pred,convn.
                                      if pred e tt
                                         then (inl (), inl(), convn)
                                          else fail)
                                 ephsimps
   else
   
 let t = term_for_simp tt in
  % (abs-obid # (simp+ list)) list %
  let obalist = apply_alist (ref_state_get simp_ref_state
					   (current_ref_environment_index `simp`))
                            (opid_of_term t) in
  let ll = if is_var_term t then obalist
           else filter ((abstraction_match_p t) o fst) obalist in

   flatten (map (\obid,l. map_omitting_failures
                           (\ (uobid, staticp, note, pred, convn).
			       if (pred e t)
                                  then (inr uobid, inr note, convn)
                                  else fail)
                            (simpset_filter e tt l))
                ll)
;;

let lookup_simpset tt =
 let t = term_for_simp tt in
  let obalist = apply_alist (ref_state_get simp_ref_state
					   (current_ref_environment_index `simp`))
                            (opid_of_term t) in
    (filter ((abstraction_match_p t) o fst) obalist)
;;

let lookup_simpset_convns e tt =
  let t = term_for_simp tt in
  let obalist = apply_alist (ref_state_get simp_ref_state
					   (current_ref_environment_index `simp`))
                            (opid_of_term t) in
  let ll = if is_var_term t then obalist
           else filter ((abstraction_match_p t) o fst) obalist in

   flatten (map (\obid,l. map_omitting_failures
                           (\ (uobid, staticp, note, pred, convn).
			       if not staticp & (pred e t)
                                  then (inr uobid, inr note, convn)
                                  else fail)
                            (simpset_filter e tt l))
                ll)
;;



% 
do simpset
%

letref simpset_ref_state = 
  new_ref_state `simpset` 
   flatten
   (\data cdata . merge_list_alist cdata data)
   ([] : (object_id # (tok # (object_id list)) list) list)
   ([] : (tok # (object_id list)) list) 
;;


update_ref_state_view
 (\ (). simpset_ref_state)
 (ref_state_view_list_entry
    (\tok,obids.
       make_term (tok,[])
          [[],map_to_ilist ioid_term
                       icons_op
                       obids]))
;;

let lookup_simpset_simp_updates simpset =
  apply_alist (ref_state_get simpset_ref_state (current_ref_environment_index `simpset`))
              simpset
;;


   
let simpset_add_data oid data = 
 simpset_ref_state  := ref_state_set_data simpset_ref_state [oid, data];;

let simpset_add uobid data =
  reset_ref_environment_data uobid;
  map (\n,oids. map (note_dependency `reference_environment_update`) oids) data;
  add_ref_environment_data uobid `simpset` simpset_add_data data
;;

let undeclare_simpset oid =
  (simpset_ref_state := ref_state_remove simpset_ref_state oid; ())
 ? ()
;;

add_ref_environment_undeclare_hook `simpset` undeclare_simpset;;

let ref_add_simpset_aux index edges items =
 simpset_ref_state
   := declare_ref_state_data_indirect `simpset` simpset_ref_state index items edges
;;

update_ref_state_merge `simpset` (ref_state_merge_build `simpset` ref_add_simpset_aux)
;;

let simpset_do_updates oid edges oids =
 %tty_print "simpset_do_updates"; %%view_show_oids edges; view_show_oids oids;%
 simpset_ref_state := ref_state_do_updates simpset_ref_state oid oids edges
;  %tty_print "simpset_do_updates done";%
()
;;

add_reference_environment_update_hook `simpset` simpset_do_updates;;

let lookup_simpsets addp names = 
  map (\obid. addp, obid)
      (flatten (map lookup_simpset_simp_updates names))
;;

let WithSimpsets addp names T p = with_simpset_context (lookup_simpsets addp names) T p;;
let WithSimpsetsOnly names T p = with_simpset_context_aux false (lookup_simpsets true names) T p;;

let WithSimpsetsC names C e t = with_simpset_contextC (lookup_simpsets true names) C e t;;

let WOSimpC uobid = with_simpset_contextC [false,uobid];;
let WOSimp uobid = with_simpset_context [false,uobid];;



				       