
%
I removed a few status checks for `COMPLETE` for lemmas. If in statement table then that should
be good enough. This is not same though as being in statement table may be different then being complete.
%


 
%

	Finding obid's for 4.2 statements: 2 possibilities

	1. require statements to be included in a global directory and lookup oid's there.
	   + could find oids even if not active.
	   - have to maintain dir, ie add/remove oids. 
	2. require statements have name property and have statement table maintain a
	   hash table on names. Name property would need to be broadcast (be part of substance).

 using 2 the following are defined.
   lemma_lookup : tok -> object_id
   statement_lookup : object_id -> term

   not attractive naming but consistent with v4-v5 structure names.

  both cases have problems with name clashes.
%


% assuming statement dir fttb. %
% Perf todo : cache ((root `theories`) `statements`) %

% let statement_oid n = (child (child (root `theories`) `statements`) name);; %

let statement_p = can statement_lookup;;
let is_statement name = can (\n. lemma_lookup n) name;;
let is_complete_thm name = is_statement (string_to_tok name);;
let goal_of_statement name =  statement_lookup (lemma_lookup name);;
let goal_of_thm_object = goal_of_statement;;

let is_statement_obid obid = can (\oid. statement_lookup oid) obid;;


let match_names_of_statements pattern =
 letref acc = []:tok list in
   map_statement_names pattern
      (\name oid. acc := (name . acc); ())
  ; acc
;;


let names_of_statements_with_prefix prefix =
   match_names_of_statements (concatenate_strings ["^"; (tok_to_string prefix)])
;;



% todo %
let library_with_prefix prefix =
 let pattern = (concatenate_strings ["^"; (tok_to_string prefix)]) in
 let matchf = string_match_f true pattern in
				     
 letref acc = match_names_of_statements pattern in
  map_abstractions (\oid. let name = name_of_lemma oid in
			    if (matchf (tok_to_string name))
			       then (acc := (name . acc); () )
			       else ())
  ; acc
;;

letref dummy_variable = string_to_variable "";;


let ab_attrs_of_term t = 
 let attrs, lhs, rhs, expandable_p =  abstraction_of_term t in
	map tok_to_string  attrs
;;

let abstraction_definition_of_object = lhs_rhs_of_abstraction_by_name;;


let display_message s =
 message_emit [`display`] [] [s] [];;


let statement_lookup_by_name n = statement_lookup (lemma_lookup n);;
let object_body_to_term = statement_lookup_by_name;;

let refresh() = ();;
let jump tok = ();;



let statement_proven_p oid = not (null (proofs_of_statement oid));;

let create_and_check_thm_obj proof stringa stringb =
 raise_error nil ``create_and_check_thm_obj`` 
	      [(itext_term stringa); (itext_term stringb)]
 ; ()
;; 






%
;;;;	
;;;;	lib_add_thm
;;;;	
;;;;	
;;;;	
;;;;	


;;;;	Refiner alist :
;;;;	  - alists updated by mapping over library
;;;;	
;;;;	
;;;;	<alist>		: TOKEN {name of alist}
;;;;	
;;;;	opid_alist_update_order : tok{alist} -> unit
;;;;	  - adds or updates ``theories state <alist>`` object with
;;;;	    names of objects matching <opid>_<alist><suffix> pattern.
;;;;	    new items are appended to the order by default preorder of theories directory tree.
;;;;	    the order of old items is not modified by update but may be modified directly by editing.
;;;;	  - this is an edit function.
;;;;	
;;;;	opid_alist_names	: tok{opid} -> tok{alist} -> tok list
;;;;	  - returns active statement names matching <opid>_<alist><suffix> ordered
;;;;	    by ``theories state <alist>`` object if any.		  
;;;;	    if no such object then maps over theories directory and produces an order.
;;;;	
;;;;	proactively update caches by having transaction end hook.
;;;;	  - add resets for alists not currently under cache control.
;;;;	
;;;;	
;;;;	alists :
;;;;	  - functionality
;;;;	  - transitivity
;;;;	  - weakening
;;;;	  - wf 
;;;;	  - inc
;;;;	  - qinc
;;;;	
;;;;	
;;;;	initialize_rw_lemma_caches - resets :
;;;;	  transitivity_lemma_alist
;;;;	  functionality_lemma_alist
;;;;	  inversion_lemma_alist
;;;;	  weakening_lemma_alist
;;;;	
;;;;	 * added call to reset whenever any lemmas in touch history.
;;;;	   could look for matching lemmas to avoid resets.
;;;;	 
;;;;	 * update_all_caches_from_history resets wf caches.
;;;;	
;;;;	 * decidable__ sq_stable__ reset at any lemma touch.
;;;;	
;;;;	 * inc, qinc alist reset at any lemma touch
;;;;	
;;;;	
;;;;	no opid : 
;;;;	  - decidable__ 
;;;;	  - sq_stable__
;;;;	
;;;;	  - make function to report lemmas and dependencies.
;;;;	  - develop method to allow user to specify order for affected lemmas.
;;;;	      * have ml function which specifies variable and relative order 
;;;;		of two members.
;;;;	      * have object which explicitly forces order for a variable.
;;;;		could be same as report. Ie, report updates object.
;;;;
;;;;	representation of order :
;;;;	  - pairs, ie graph : difficult to maintain if list is 
;;;;	  - precedence tree : complicated to manage.
;;;;	  - list : could be projected from pairs.
;;;;	
;;;;	FTTB : a list of lists
;;;;	
;;;;	opid alist : (tok{opid} -> tok{name} list) list
;;;;	
;;;;	``theories state <alist name>``
;;;;	
;;;;	
;;;;	
;;;;	
;;;;	sort_opid_alist	: tok{alist name} -> tok{opid} -> tok{name} list -> tok{name} list
;;;;	functionality : <opid>_functionality<rest>
;;;;	
%

% 
;;;;	
;;;;	FTTB : assume naming scheme is <opid>_<alist><suffix>
;;;;	
;;;;	Find all matching pattern then group by opid to get list of lists.
;;;;	
;;;;	
;;;;	
%

%
;; <opid><_alist_name><suffix>
;; (string{_alist_name} -> tok list -> (string{opid} # tok list) list)
%


let opid_alist_order opid alist =
  map_isexpr_to_list itok_cons_op token_of_itoken_term
    (lib_eval_to_term (token_ap (token_ap (begin_ap "opid_alist_order ") opid) alist))
;;

let opid_alist_name_sort opid alist names =
 let order = opid_alist_order opid alist in
  let ordered = filter (\n. member n names) order in
   let other = filter (\n. not (member n ordered)) names in
    if (null other) then ordered
    else append ordered other
;;


let opid_alist_names opid alist =
  opid_alist_name_sort opid alist
    (match_names_of_statements
      (concatenate_strings ["^"; tok_to_string opid; "_"; (tok_to_string alist)]))
;;

let is_term_o oid t = equal_oids_p (obid_of_abstraction_term t) oid;;


%
;;;;	
;;;;	Replayability : hindred by arbitrary updates to reference variables.
;;;;	
;;;;	  - letref
;;;;	
;;;;	  - lib map : 
;;;;	     * match_names_of_statements.
;;;;	     * names_of_statements_with_prefix.
;;;;	
;;;;	 In both cases need to narrow scope of reference.
;;;;	
;;;;	
;;;;	  - desire updates replace old value.
;;;;	      * if refvar contains pointer to closure and caller updates
;;;;	        by building new closure and rebinding then that is bad. 
;;;;	
;;;;
;;;;	  - need some method of forcing values.
;;;;	  - diff objects see diff values by seeing into  
;;;;	
;;;;	
;;;;	 - and update to a refvar supplies oid to identify updater.
;;;;	 - oids are accessible 
;;;;	
;;;;	 - refvar is alist of oid and value or some recursive data type.
;;;;	
;;;;	
;;;;	EG: soft_abstractions : tok list
;;;;	
;;;;	 soft_abstractions : (object_id # tok list) list
;;;;	 
;;;;	 soft_abstractions := append new soft_abstractions 
;;;;	
;;;;	 update_soft_abstractions oid new =
;;;;	   - if oid present then append new with list of tail and then
;;;;	     rebuild all outer lists.
;;;;	
;;;;	 letref current_soft_abstractions : object_id
;;;;	 
;;;;	soft_abstractions is then the value indexed by current_soft_abstractions
;;;;
;;;;	
;;;;	define objects which specify reference state and then require proofs to
;;;;	 supply such an object at refinement time to set ref values.
;;;;	
;;;;	
;;;;	  - lib map : failure or abort at use insufficient, it needs to act as though they
;;;;	      do not exist.
;;;;	
;;;;	  - map functions need to have state arg.
;;;;	     - states could be built from layer info for theories. In any theory all lemmas from
;;;;	       theories upto ind including present of lower level are visible. thus state is specication of 
;;;;	      theory, theory order and current layer level (maybe derive level from an object expected to be
;;;;	      in highest accessible level.
;;;;	
;;;;	
;;;;	refstate : (oid # * list) list
;;;;	
;;;;	
;;;;	
;;;;	
;;;;	
;;;;	
;;;;	
;;;;	refstate_update : (* -> **) -> ((object_id # (* -> *)) # *) list -> (* -> *) -> object_id -> **
;;;;	  - (* -> **) : assign to ref var.
;;;;	  - ((object_id # (* -> *)) # *) list : current refstate
;;;;	  - (* -> *) : update ref value
;;;;	  - object_id : index
;;;;	
;;;;	 * order of result is arbitrary, ie may remove and prepend or update in place.
;;;;	 
;;;;	refstate_update : (* -> **) -> ((object_id # (object_id list # (* -> *))) # * # object_id list) list -> (* -> *)
;;;;					 -> (object_id list) -> object_id -> **
;;;;	  - (* -> **) : assign to ref var.
;;;;	  - ((object_id # (object_id list {dependencies} # (* -> *))) # *) list : current refstate
;;;;	      * all object_ids in dependencies must occur as indices later in list. 
;;;;	      * an object may occur as in index only once.
;;;;	      * value only includes updates from closure of dependencies
;;;;	      * fails if update would cause cycle.
;;;;	  - (* -> *) : update ref value
;;;;	  - object_id list : updates of elements must occur before update of index.
;;;;	      all elements of list must be present or fails. 
;;;;	  - object_id : index
;;;;	
;;;;	
;;;;	idiom : refstate_update with identity update but that creates dependencies on all current index obids.
;;;;	 then use that oid for lookup. 
;;;;	
;;;;	
;;;;	refstate_lookup : oid -> *
;;;;	
;;;;	reference : a use of reference the reference creates a dependency on all index obids in scope.
;;;;	(* # ** # *** # **** # *****) -> ****)
;;;;	
;;;;	* oid_graph : object_id # (*{cdata} # object_id list{closure}) # (**{data} # object_id list{edges}) list
;;;;	   - indexed by object_id 
;;;;	   - assume infrequent update but frequent lookup of cdata or data
;;;;	
;;;;	
;;;;	incremental update :
;;;;      * all object_ids in dependencies must occur as indices later in list. 
;;;;      * an object may occur as in index only once.
;;;;	  
;;;;	  - element for current oid is removed
;;;;	  - keeping order stable separate into dependency closure, and remainder.
;;;;	  - append remainder (element . clousre) for new graph.
;;;;
;;;;	Dependents will be stale in that their cached closure and cdata may not be accurate.
;;;;	Thus invariants are true only wrt to the cached closures. However, it is expected 
;;;;	that external dependency tracking will force updates for stale data.
;;;;	(TODO: need to include static dependencies in code order computations).
;;;;	

;;; not relevant :

compatv4.ml:letref dummy_variable = string_to_variable "";;
compile-com.ml:letref ml_path = ``~nuprl nuprl4i nuprl5 nuprl4.1 lib ml standard`` ;;
compile-com.ml:letref bin_path = ``~nuprl nuprl4i nuprl5 nuprl4.1 lib ml standard bin`` 
compile-ml.ml:letref ml_path = ``~nuprl nuprl4i nuprl5 lib ml standard`` ;;
compile-ml.ml:letref bin_path = ``~nuprl nuprl4i nuprl5 lib ml standard bin`` ;;
pproof.ml:letref rule_width = 80;;
pproof.ml:letref pp_width = 95 ;;
pproof.ml:letref pp_same_hyps = false ;;
pproof.ml:letref pp_same_concl = false ;;
pproof.ml:letref pp_always_indent = false ;;
pproof.ml:letref pp_addrs = false ;;
pproof.ml:letref pp_number_branches = true;;
primitives.ml:letref default_le_var_in_extract_terms = `\\v`;;
theory.ml:letref theory_filenames = [] : (string # string) list ;;
theory.ml:letref theory_ancestors = [] : (string # string list) list ;;
theory.ml:letref theory_filename_ext = ".lisp";;
theory.ml:letref begin_theory_delimiter = "BEGIN_" ;;
theory.ml:letref end_theory_delimiter = "END_" ;;
theory.ml:letref begin_theory_suffix = "_begin" ;;
theory.ml:letref end_theory_suffix = "_end" ;;
theory.ml:letref theory_orphans = ([]:string list) ;;
theory.ml:letref fresh_objects = ([]:string list) ;;

atomic-tactics.ml:letref wf_pretty_up = true ;;
compute-aux3.ml:letref dc_debug = false ;;
compute-tactics.ml:letref tac_debug = true ;;
sup-inf.ml:letref supinf_info = [] : (term # term) list
sup-inf.ml:letref si_var_index = 0 ;;

;;; protected :
abstraction.ml:letref soft_abstractions = [] : tok list ;;
equality-tactics.ml:letref ReflEqCD_cache  = [] : (tok # (bool -> tactic) list) list ;;
equality-tactics.ml:letref ReflEqCD_cache_enable = true ;;
equality-tactics.ml:letref NonReflEqCD_cache = [] : (tok # (bool -> tactic) list) list ;;
equality-tactics.ml:letref NonReflEqCD_cache_enable = true ;;
atomic-tactics.ml:letref D_additions 
atomic-tactics.ml:letref Trivial_additions = [`LogicAxiom`, LogicAxiom
general-tactics.ml:letref decidable__lemmas = (inl () : (unit + (tok list)));;
general-tactics.ml:letref sq_stable__lemmas = (inl () : (unit + (tok list)));;
rw-types.ml:letref root_rel_relative_strengths =  [] : (tok # tok) list ;;
rw-types.ml:letref order_rel_families = [] : (tok # reln list) list ;;
rw-types.ml:letref order_rel_relative_strengths =  [] : (reln # reln) list ;;
rw-types.ml:letref lin_order_check_funs = [`less_than`,is_int_rel] ;;
lib-dep-1.ml:letref YUnrollC = IdC ;;
lib-dep-1.ml:letref pi1_evalC = IdC ;;
lib-dep-1.ml:letref pi2_evalC = IdC ;;
simp-tactics.ml:letref ForceReduce_alist = [`lambda`,\f.BetaC] : (tok # (tok -> convn)) list ;;
recdef.ml:letref RecUnfoldFold_alist = [] : (tok # convn # convn) list
recdef.ml:letref RecEta_alist = [] : (tok # convn # convn) list
inc-tactics-3.ml:letref set_inc_tactics = [] : (tok # (int->tactic) # tactic) list
type-inc.ml:letref set_inc_info = [] : (tok # tok) list
type-inc.ml:letref set_inc_tactics = [] : (tok # (int->tactic) # tactic) list
inc-tactics-2.ml:letref inc_alist = ([]: (tok # (tok list)) list);;
inc-tactics-2.ml:letref qinc_alist = ([]: (tok # (tok list)) list);;
just-manips.ml:letref inversion_lemma_alist = [] : 
just-manips.ml:letref weakening_lemma_alist = [] : ((reln # reln) # (just -> just)) list ;;
just-manips.ml:letref functionality_lemma_alist = 
just-manips.ml:letref quick_fiat_conv = false;;
just-manips.ml:letref transitivity_lemma_alist = [] : 
sup-inf.ml:letref arith_property_inf_alist = [] 



;;;; probably doesn't matter (ie, haven't found a modification in code in an objects)
;;;; but could be protected.

equality-tactics.ml:letref NonReflEqCD_Autotactic = Id ;;
equality-tactics.ml:letref do_cumulativity_in_EqCD = true
equality-tactics.ml:letref EqCD_additions = [] : (tok # tactic) list ;;
equality-tactics.ml:letref EqExtWithLambdaTac = AddHiddenLabel `wf`;;
equality-tactics.ml:letref EqExtWithRLambdaTac = AddHiddenLabel `wf`;;
general-tactics.ml:letref GenConcl = NewGenConcl ;;
general-tactics.ml:letref EqTypeCD_additions = [] : (tok # tactic) list;;
general-tactics.ml:letref EqTypeHD_additions = [] : (tok # (int -> tactic)) list;;



;;;; ???

apply-conv.ml:letref quick_rw = false ;;
arith.ml:letref arith_types = ``int nat nat_plus int_iseg 
arith.ml:letref types_with_arith_properties = [] : tok list ;;

autotactic.ml:letref Auto_additions = [] : (tok # tactic) list ;;
basic-tactics.ml:letref intuitionistic_prop_opids 
cache.ml:letref cache_control = 
comp-seq-manips.ml:letref atomic_n_ap_rw_alist = [] : ((tok # int) # tok) list ;;
compute-aux3.ml:letref (Ref_SqEqSymmetry: tactic) p = failwith `SqSwapConcl: tactic not initialized`;;
compute-convs.ml:letref MacroC_info = void_term,void_term ;;
compute-tactics.ml:letref (Ref_SqSubstWithTaggedTerm: term -> int -> tactic) t i =
conversionals.ml:letref just_cache = [] : (int # just) list ;;
conversionals.ml:letref just_count = 0 ;;
env.ml:letref sub_env_cache = initial_sub_env_cache



inc-tactics-3.ml:letref InclusionAuto = Id ;;
inclusion-tactics.ml:letref Subtype_additions = [] : (tok # tactic) list
inclusion-tactics.ml:letref LemmaSubtype p = Fail p
inclusion-tactics.ml:letref ProveSubtyping1 = DefaultProveSubtyping3 ;;
inclusion-tactics.ml:letref inc_debug = false ;;
lib.ml:letref object_kind_alist = 
match-ext.ml:letref match_info = ([],void_term) :(var list # term) ;;
match-ext.ml:letref match_arg_info = 
match-sub.ml:letref ac_conflict = (tok_to_var `x`,1,[]) : var # int # var list
match-sub.ml:letref ac_null_var_index = 0;;
match-sub.ml:letref substitutions_maintain_bound_var_identities = true ;;
match-sub.ml:letref parm_polarity_alist = [] : ((tok # int) # int list) list ;;
match-sub.ml:letref subterm_polarity_alist = [] : ((tok # int) # int list) list ;;
monitor.ml:letref call_hist = [""] ;;
monitor.ml:letref display_cursor_at_left = false ;;
monitor.ml:letref tactic_monitor_sel = `time` ;;
monitor.ml:letref do_monitoring = false;;
monitor.ml:letref pcache_name = `none` ;;
monitor.ml:letref proof_cache_kind = `basic`;;
new-var.ml:letref indexed_ids = []: (tok # tok list) list ;;
prog-case.ml:letref (pattern_list : (tok # tok # bool # tok list # bool # term) list) =
prog-enum.ml:letref enumeration_list = [] : (tok # tok # tok list) list;;
sequent.ml:letref nrefine_succs = 0 ;;
sequent.ml:letref nrefine_fails = 0 ;;
sequent.ml:letref refine_succs = [`equality`] ;;
sequent.ml:letref refine_fails = [`equality`] ;;
sequent.ml:letref refine_rules = [`equality`] ;;
sequent.ml:letref debug_refine = false;;
sequent.ml:letref show_labels = true;;
simp-tactics.ml:letref red_str_spine = ``1 2 3 4 5 6 7 8 9`` ;;
simp-tactics.ml:letref max_red_strength = `9` ;;
simp-tactics.ml:letref min_red_strength = `1` ;;
simp-tactics.ml:letref reduction_strengths = [`variable`,`9`] : (tok # tok) list ;;
simp-tactics.ml:letref reducible_abs = [] : tok list ;;
simp-tactics.ml:letref conv_registry = [] : (tok # tok # convn # convn) list;;
simp-tactics.ml:  letref up = false in
sup-inf.ml:letref si_int_subset_preds =
tactic-funs.ml:letref atomic_comp_trivial_abstractions = ``le gt ge squash``
tacticals.ml: letref l = Tlist in
tacticals.ml:letref main_labels = 
tacticals.ml:letref predicate_labels = 
tacticals.ml:letref stop_labels = ([]: tok list) ;;
tacticals.ml:letref proof_label_order = ``predicate aux main any`` ;;
tacticals.ml:letref enable_messages = false 
tactics.ml:letref tactic_files =
tactics.ml:letref refiner_files =
term.ml:letref principle_arg_alist =
txform-tactics.ml:letref saved_proofs = []: (tok#proof) list ;;
txform-tactics.ml:letref saved_proof_index = 0;;
txform-tactics.ml:letref tlist = [void_term];;
type-inc.ml:letref supertype_funs = [] 
type-inf.ml:letref default_level = mk_var_level_exp `*default*` ;;
type-inf.ml:letref get_type_additions_alist = [] 
type-inf.ml:letref default_level_inc = 17
wf-cache.ml:letref proof_cache = []
wf-cache.ml:letref proof_cache_aps = 0 ;;
wf-cache.ml:letref proof_cache_updates = 0 ;;
wf-cache.ml:letref pc_num_thms = 5 ;;
wf-cache.ml:letref wf_cache_p = true;;
% 
